import network_constants as nc
from security.token_manager import TokenManager

import requests

def add_table(use_case: str, table_name: str):
    '''
    take the columns and add the mappings at the server
    replace all "/"'s in the internal representation with a "_"
    '''
    jwt = TokenManager.getInstance().getToken()

    # TODO Manuel: check back with alex

    use_case = "car-sharing"
    columns = [
        # "docType",
        "documents",
        "connection"
    ]
    
    columns = { c : c for c in columns }
    columns["UniqueID"] = "id"

    columns["document1id"] = "documents[0]//id"
    columns["document1collection"] = "documents[0]//collection"
    columns["document1hash"] = "documents[0]//hash"

    columns["databaseType"] = "connection//databaseType"
    columns["database"] = "connection//database"
    columns["host"] = "connection//host"
    columns["port"] = "connection//port"
    columns["username"] = "connection//username"
    columns["password"] = "connection//password"
    
    
    url = f"https://articonf1.itec.aau.at:30420/api/use-cases/{use_case}/tables"

    table = {
        "name": table_name,
        "mappings": columns
    }

    response = requests.post(
            url,
            verify=False, 
            proxies = { "http":None, "https":None },
            headers = { "Authorization": f"Bearer {jwt}"},
            json = table
        )

    print(url+": "+str(response.status_code))

def add_layers(use_case:str, table_name: str):
    layers = [
        {
            "use_case": use_case,
            "table": table_name,
            "name": "document_layer",
            "properties": [
                "UniqueId",
                "document1id",
                "document1collection",
                "document1hash"
                
                
            ],
            "cluster_properties": [
                ##TODO discuss with other to see if we keep them?
                "document1id",
                "document1collection"
            ]
        },
        {
            "use_case": use_case,
            "table": table_name,
            "name": "connection_layer",
            "properties": [
                "UniqueId",
                "database",
                "databaseType",
                "host",
                "port"
                
                
            ],
            "cluster_properties": [
                ##TODO discuss with other to see if we keep them?
                "document1id",
                "document1collection"
            ]
        },
        {
            "use_case": use_case,
            "table": table_name,
            "name": "connection_layer",
            "properties": [
                "UniqueId",
                "username",
                "password"
                
                
            ],
            "cluster_properties": [
                ##TODO discuss with other to see if we keep them?
                "username"
            ]
        }
    ]

    jwt = TokenManager.getInstance().getToken()

    for layer in layers:
        url = f"https://articonf1.itec.aau.at:30420/api/layers"

        response = requests.post(
            url,
            verify=False, 
            proxies = { "http":None, "https":None },
            headers = { "Authorization": f"Bearer {jwt}"},
            json = layer
        )

    print(url+": "+str(response.status_code))

def main(use_case: str):
    print("HASH")
    table_name = "hash"
    add_table(use_case,table_name)
    add_layers(use_case,table_name)